#include <iostream>
#include "cxx/dllclass.h"

extern DllClass global_dllclass1;
extern DllClass global_dllclass2;
extern int global_int_variable;

int main () { 
  std::cout 
    << "Global integer variable = " << global_int_variable << std::endl
    << "DllClass 1 (Imported from DLL):" << std::endl
      << "  virtual_method = " << global_dllclass1.virtual_method () << std::endl
      << "  non_virtual_method = " << global_dllclass1.non_virtual_method () 
        << std::endl
      << "  instances = " << global_dllclass1.instances << std::endl
    << "DllClass 2 (Imported from DLL):" << std::endl
      << "  virtual_method = " << global_dllclass2.virtual_method () << std::endl
      << "  non_virtual_method = " << global_dllclass2.non_virtual_method () 
        << std::endl
      << "  instances = " << global_dllclass2.instances << std::endl;

  DllClass local_dllclass (3);
  std::cout
    << "DllClass (Local):" << std::endl
      << "  virtual_method = " << local_dllclass.virtual_method () << std::endl
      << "  non_virtual_method = " << local_dllclass.non_virtual_method () 
        << std::endl
      << "  instances = " << DllClass::instances << std::endl;
  return 0;
}

